package com.vendor.burn.ui.burners;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.vendor.burn.Messages;
import com.vendor.burn.model.PartitionItem;
import com.vendor.burn.model.PlatformType;
import com.vendor.burn.model.define.IBurner;
import com.vendor.burn.model.define.IFastbootProgressMonitor;
import com.vendor.burn.model.devices.IMergeBurner;
import com.vendor.burn.model.devices.burners.MergeBurner;
import com.vendor.burn.model.devices.unknown.UnknownDevice;
import com.vendor.burn.ui.burners.PartitionComposite;
import com.vendor.burn.utilitily.ToolUtils;
import java.util.List;
import org.eclipse.jface.viewers.CheckboxTableViewer;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Layout;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Text;

public class MergeComposite extends PartitionComposite {
  private Button browseButton;
  
  private Button makeMergeButton;
  
  public MergeComposite(Composite parent, int style, IBurner emmcBurn) {
    super(parent, style, emmcBurn);
  }
  
  protected void createContents(Composite parent) {
    parent.setLayout((Layout)new FillLayout());
    Composite com = new Composite(parent, 0);
    com.setLayout((Layout)new GridLayout(6, false));
    GridData gridData = new GridData(1808);
    com.setLayoutData(gridData);
    this.useXMLPathAsParentButton = new Button(com, 32);
    GridData layoutData = new GridData(1, 1, false, false);
    this.useXMLPathAsParentButton.setLayoutData(layoutData);
    this.useXMLPathAsParentButton
      .setText(Messages.PartitionComposite_LABEL_Default_Use_XML_Path);
    this.useXMLPathAsParentButton.addListener(13, (Listener)new Object(this));
    this.useXMLPathAsParentButton.setSelection(true);
    Label label = new Label(com, 0);
    label.setText(Messages.MergeComposite_LABEL_PartitionFile);
    layoutData = new GridData(1, 1, false, false);
    layoutData.horizontalIndent = 20;
    label.setLayoutData(layoutData);
    this.tableFileText = new Text(com, 2048);
    GridData tableFileTextGD = new GridData(4, 1, true, false);
    tableFileTextGD.horizontalIndent = 5;
    tableFileTextGD.horizontalSpan = 2;
    this.tableFileText.setLayoutData(tableFileTextGD);
    this.tableFileText.addListener(14, (Listener)new Object(this));
    this.browseButton = new Button(com, 0);
    layoutData = new GridData();
    ToolUtils.setWidthForOS(layoutData, 60, 70);
    this.browseButton.setLayoutData(layoutData);
    this.browseButton.setText(LABEL_BROWSE);
    this.browseButton.addListener(13, (Listener)new Object(this));
    this.saveButton = new Button(com, 0);
    this.saveButton.setLayoutData(layoutData);
    this.saveButton.setText(LABEL_SAVE);
    this.saveButton.addListener(13, (Listener)new Object(this));
    if (getBurner().getBurnContext().getPlatformType() == PlatformType.CA || ((UnknownDevice)
      getBurner().getBurnContext()
      .getDeviceSetting()).isSupportBurnByLibBootrom()) {
      Button alignButton = new Button(com, 32);
      layoutData = new GridData(1, 1, false, false);
      alignButton.setLayoutData(layoutData);
      alignButton
        .setText(Messages.PartitionComposite_LABEL_Default_Use_XML_Path);
      alignButton.setVisible(false);
    } 
    createButtons(com);
    Control tableControl = createItemTable(com);
    this.itemViewer = (CheckboxTableViewer)tableControl.getData();
    this.itemViewer.setInput(getBurner());
    GridData layoutData2 = new GridData(4, 4, true, true, 6, 1);
    tableControl.setLayoutData(layoutData2);
    initData();
  }
  
  protected void createButtons(Composite parent) {
    Composite buttonComp = new Composite(parent, 0);
    buttonComp.setLayout((Layout)new GridLayout(1, false));
    GridData gd = new GridData(4, 1, true, false);
    gd.horizontalSpan = 6;
    buttonComp.setLayoutData(gd);
    this.makeMergeButton = new Button(buttonComp, 0);
    GridData buttonLayoutData = new GridData(576);
    buttonLayoutData.widthHint = 120;
    this.makeMergeButton.setLayoutData(buttonLayoutData);
    this.makeMergeButton.setText(Messages.MergeComposite_MergeImage_Button);
    this.makeMergeButton.addListener(13, (Listener)new Object(this));
    buttonComp.setLayout((Layout)new GridLayout(1, true));
  }
  
  private void mergeImage() {
    IMergeBurner burner = (IMergeBurner)getBurner();
    if (checkStatus(burner.checkBeforeBurn())) {
      IFastbootProgressMonitor monitor = getProgressMonitor();
      monitor.getEvent().setBurner((IBurner)getBurner());
      List<PartitionItem> children = getBurner().getPratitionInfo().getChildren();
      int size = children.size();
      for (int i = 0; i < size; i++) {
        PartitionItem partition = children.get(i);
        if (i == size - 1 && partition.isChecked())
          if (!((MergeBurner)getBurner()).getBurnerWorker().checkLastPartition(children)) {
            enableUI();
            return;
          }  
      } 
      burner.mergeImage(monitor);
    } else {
      enableUI();
    } 
  }
  
  protected void disableUI() {
    if (this.makeMergeButton != null && !this.makeMergeButton.isDisposed())
      this.makeMergeButton.setEnabled(false); 
  }
  
  protected void enableUI() {
    if (this.makeMergeButton != null && !this.makeMergeButton.isDisposed())
      this.makeMergeButton.setEnabled(true); 
  }
}
